/**
 * Highwire Article Nav
 *
 * Copyright (c) 2010-2011 Board of Trustees, Leland Stanford Jr. University
 * This software is open-source licensed under the GNU Public License Version 2 or later
 * The full license is available in the LICENSE.TXT file at the root of this repository
 */

(function ($) {
  Drupal.behaviors.highwireNavFloat = {
    attach: function (context, settings) {
      $('.highwire-nav-float', context).once('highwire-nav-float', function() {
        var $wrapper = $(this);
        var $list = $('ul, ol', $wrapper);

        // Scrolling float
        if ($list.data('highwire-float') == '1') {
          var wrap_class = $list.data('highwire-float-class');

          // Since we are calculating heights of elements below, should be done after all the elements are loaded
          $(window).load(function(e) {
            var $this_pane = $wrapper.parent().parent();
            var $pane_last = $this_pane.siblings().last();
            var pane_last_offset = $pane_last.offset();
            var pane_last_height = $pane_last.height();
            var threshold = parseInt(pane_last_offset.top) + parseInt(pane_last_height);
            var floated = false;
            var this_pane_height = $this_pane.height();
            var topOffset = 20;
            var content_region_height = $('#section-content').height();
            var header_height = $('#section-header').height();
            var threshold_height = content_region_height + header_height - topOffset;
            var wrapDiv = '<div class="highwire-nav-float-wrapper ' + wrap_class + '"></div>';

            $(window).scroll(function(e) {
              var y_scroll_pos = window.pageYOffset;
              var currentLayout = Drupal.highwireResponsive.getCurrentLayout();

              if ((y_scroll_pos < threshold) || (threshold_height < (this_pane_height + y_scroll_pos)) || (currentLayout == 'mobile')) {

                if (floated === true) {
                  $this_pane.unwrap();
                }
                floated = false;
              }
              else if (y_scroll_pos > pane_last_offset.top && floated === false) {
                $this_pane.wrap(wrapDiv);
                $this_pane.parent()
                  .hide()
                  .css('position', 'fixed')
                  .css('top', topOffset + 'px')
                  .fadeIn('slow');
                floated = true;
              }
            });
          });
        }
      });
    }
  };
})(jQuery);
